module core.stdc.unistd;

import sys.posix.types;

// POSIX.1 (1996)
enum STDIN_FILENO = 0;
enum STDOUT_FILENO = 1;
enum STDERR_FILENO = 2;

extern(C):

// TODO: access, euidaccess, eaccess, execveat
// TODO: lseek, lseek64

int close(int fd);

// TODO: closefrom

ssize_t read(int fd, void* buf, size_t nbytes);
ssize_t write(int fd, const void* buf, size_t nbytes);

// TODO: pread, pwrite
// TODO: pipe, pipe2

uint alarm(uint seconds);
uint sleep(uint seconds);

useconds_t ualarm(useconds_t __value, useconds_t __interval);
int usleep(useconds_t __useconds);

int pause();

// TODO: chown, chdir, fchdir, etc...

enum : int {
	_SC_ARG_MAX,
	_SC_CHILD_MAX,
	_SC_CLK_TCK,
	_SC_NGROUPS_MAX,
	_SC_OPEN_MAX,
	_SC_STREAM_MAX,
	_SC_TZNAME_MAX,
	_SC_JOB_CONTROL,
	_SC_SAVED_IDS,
	_SC_REALTIME_SIGNALS,
	_SC_PRIORITY_SCHEDULING,
	_SC_TIMERS,
	_SC_ASYNCHRONOUS_IO,
	_SC_PRIORITIZED_IO,
	_SC_SYNCHRONIZED_IO,
	_SC_FSYNC,
	_SC_MAPPED_FILES,
	_SC_MEMLOCK,
	_SC_MEMLOCK_RANGE,
	_SC_MEMORY_PROTECTION,
	_SC_MESSAGE_PASSING,
	_SC_SEMAPHORES,
	_SC_SHARED_MEMORY_OBJECTS,
	_SC_AIO_LISTIO_MAX,
	_SC_AIO_MAX,
	_SC_AIO_PRIO_DELTA_MAX,
	_SC_DELAYTIMER_MAX,
	_SC_MQ_OPEN_MAX,
	_SC_MQ_PRIO_MAX,
	_SC_VERSION,
	_SC_PAGESIZE,
	_SC_RTSIG_MAX,
	_SC_SEM_NSEMS_MAX,
	_SC_SEM_VALUE_MAX,
	_SC_SIGQUEUE_MAX,
	_SC_TIMER_MAX,
	_SC_BC_BASE_MAX,
	_SC_BC_DIM_MAX,
	_SC_BC_SCALE_MAX,
	_SC_BC_STRING_MAX,
	_SC_COLL_WEIGHTS_MAX,
	_SC_EQUIV_CLASS_MAX,
	_SC_EXPR_NEST_MAX,
	_SC_LINE_MAX,
	_SC_RE_DUP_MAX,
	_SC_CHARCLASS_NAME_MAX,
	_SC_2_VERSION,
	_SC_2_C_BIND,
	_SC_2_C_DEV,
	_SC_2_FORT_DEV,
	_SC_2_FORT_RUN,
	_SC_2_SW_DEV,
	_SC_2_LOCALEDEF,
	_SC_PII,
	_SC_PII_XTI,
	_SC_PII_SOCKET,
	_SC_PII_INTERNET,
	_SC_PII_OSI,
	_SC_POLL,
	_SC_SELECT,
	_SC_UIO_MAXIOV,
	_SC_IOV_MAX = _SC_UIO_MAXIOV,
	_SC_PII_INTERNET_STREAM,
	_SC_PII_INTERNET_DGRAM,
	_SC_PII_OSI_COTS,
	_SC_PII_OSI_CLTS,
	_SC_PII_OSI_M,
	_SC_T_IOV_MAX,
	_SC_THREADS,
	_SC_THREAD_SAFE_FUNCTIONS,
	_SC_GETGR_R_SIZE_MAX,
	_SC_GETPW_R_SIZE_MAX,
	_SC_LOGIN_NAME_MAX,
	_SC_TTY_NAME_MAX,
	_SC_THREAD_DESTRUCTOR_ITERATIONS,
	_SC_THREAD_KEYS_MAX,
	_SC_THREAD_STACK_MIN,
	_SC_THREAD_THREADS_MAX,
	_SC_THREAD_ATTR_STACKADDR,
	_SC_THREAD_ATTR_STACKSIZE,
	_SC_THREAD_PRIORITY_SCHEDULING,
	_SC_THREAD_PRIO_INHERIT,
	_SC_THREAD_PRIO_PROTECT,
	_SC_THREAD_PROCESS_SHARED,
	_SC_NPROCESSORS_CONF,
	_SC_NPROCESSORS_ONLN,
	_SC_PHYS_PAGES,
	_SC_AVPHYS_PAGES,
	_SC_ATEXIT_MAX,
	_SC_PASS_MAX,
	_SC_XOPEN_VERSION,
	_SC_XOPEN_XCU_VERSION,
	_SC_XOPEN_UNIX,
	_SC_XOPEN_CRYPT,
	_SC_XOPEN_ENH_I18N,
	_SC_XOPEN_SHM,
	_SC_2_CHAR_TERM,
	_SC_2_C_VERSION,
	_SC_2_UPE,
	_SC_XOPEN_XPG2,
	_SC_XOPEN_XPG3,
	_SC_XOPEN_XPG4,
	_SC_CHAR_BIT,
	_SC_CHAR_MAX,
	_SC_CHAR_MIN,
	_SC_INT_MAX,
	_SC_INT_MIN,
	_SC_LONG_BIT,
	_SC_WORD_BIT,
	_SC_MB_LEN_MAX,
	_SC_NZERO,
	_SC_SSIZE_MAX,
	_SC_SCHAR_MAX,
	_SC_SCHAR_MIN,
	_SC_SHRT_MAX,
	_SC_SHRT_MIN,
	_SC_UCHAR_MAX,
	_SC_UINT_MAX,
	_SC_ULONG_MAX,
	_SC_USHRT_MAX,
	_SC_NL_ARGMAX,
	_SC_NL_LANGMAX,
	_SC_NL_MSGMAX,
	_SC_NL_NMAX,
	_SC_NL_SETMAX,
	_SC_NL_TEXTMAX,
	_SC_XBS5_ILP32_OFF32,
	_SC_XBS5_ILP32_OFFBIG,
	_SC_XBS5_LP64_OFF64,
	_SC_XBS5_LPBIG_OFFBIG,
	_SC_XOPEN_LEGACY,
	_SC_XOPEN_REALTIME,
	_SC_XOPEN_REALTIME_THREADS,
	_SC_ADVISORY_INFO,
	_SC_BARRIERS,
	_SC_BASE,
	_SC_C_LANG_SUPPORT,
	_SC_C_LANG_SUPPORT_R,
	_SC_CLOCK_SELECTION,
	_SC_CPUTIME,
	_SC_THREAD_CPUTIME,
	_SC_DEVICE_IO,
	_SC_DEVICE_SPECIFIC,
	_SC_DEVICE_SPECIFIC_R,
	_SC_FD_MGMT,
	_SC_FIFO,
	_SC_PIPE,
	_SC_FILE_ATTRIBUTES,
	_SC_FILE_LOCKING,
	_SC_FILE_SYSTEM,
	_SC_MONOTONIC_CLOCK,
	_SC_MULTI_PROCESS,
	_SC_SINGLE_PROCESS,
	_SC_NETWORKING,
	_SC_READER_WRITER_LOCKS,
	_SC_SPIN_LOCKS,
	_SC_REGEXP,
	_SC_REGEX_VERSION,
	_SC_SHELL,
	_SC_SIGNALS,
	_SC_SPAWN,
	_SC_SPORADIC_SERVER,
	_SC_THREAD_SPORADIC_SERVER,
	_SC_SYSTEM_DATABASE,
	_SC_SYSTEM_DATABASE_R,
	_SC_TIMEOUTS,
	_SC_TYPED_MEMORY_OBJECTS,
	_SC_USER_GROUPS,
	_SC_USER_GROUPS_R,
	_SC_2_PBS,
	_SC_2_PBS_ACCOUNTING,
	_SC_2_PBS_LOCATE,
	_SC_2_PBS_MESSAGE,
	_SC_2_PBS_TRACK,
	_SC_SYMLOOP_MAX,
	_SC_STREAMS,
	_SC_2_PBS_CHECKPOINT,
	_SC_V6_ILP32_OFF32,
	_SC_V6_ILP32_OFFBIG,
	_SC_V6_LP64_OFF64,
	_SC_V6_LPBIG_OFFBIG,
	_SC_HOST_NAME_MAX,
	_SC_TRACE,
	_SC_TRACE_EVENT_FILTER,
	_SC_TRACE_INHERIT,
	_SC_TRACE_LOG,
	_SC_LEVEL1_ICACHE_SIZE,
	_SC_LEVEL1_ICACHE_ASSOC,
	_SC_LEVEL1_ICACHE_LINESIZE,
	_SC_LEVEL1_DCACHE_SIZE,
	_SC_LEVEL1_DCACHE_ASSOC,
	_SC_LEVEL1_DCACHE_LINESIZE,
	_SC_LEVEL2_CACHE_SIZE,
	_SC_LEVEL2_CACHE_ASSOC,
	_SC_LEVEL2_CACHE_LINESIZE,
	_SC_LEVEL3_CACHE_SIZE,
	_SC_LEVEL3_CACHE_ASSOC,
	_SC_LEVEL3_CACHE_LINESIZE,
	_SC_LEVEL4_CACHE_SIZE,
	_SC_LEVEL4_CACHE_ASSOC,
	_SC_LEVEL4_CACHE_LINESIZE,
	_SC_IPV6 = _SC_LEVEL1_ICACHE_SIZE + 50,
	_SC_RAW_SOCKETS,
	_SC_V7_ILP32_OFF32,
	_SC_V7_ILP32_OFFBIG,
	_SC_V7_LP64_OFF64,
	_SC_V7_LPBIG_OFFBIG,
	_SC_SS_REPL_MAX,
	_SC_TRACE_EVENT_NAME_MAX,
	_SC_TRACE_NAME_MAX,
	_SC_TRACE_SYS_MAX,
	_SC_TRACE_USER_EVENT_MAX,
	_SC_XOPEN_STREAMS,
	_SC_THREAD_ROBUST_PRIO_INHERIT,
	_SC_THREAD_ROBUST_PRIO_PROTECT,
	_SC_MINSIGSTKSZ,
	_SC_SIGSTKSZ,
}

long sysconf(int __name);

pid_t getpid();
pid_t getppid();
pid_t getpgrp();

// TODO: getpgid

int setpgid(pid_t __pid, pid_t __pgid);

// TODO: setpgrp

pid_t setsid();

// TODO: getsid

uid_t getuid();
uid_t geteuid();
gid_t getgid();
gid_t getegid();

// TODO: getgroups, group_member

int setuid(uid_t __uid);

// TODO: setreuid, seteuid

int setgid(gid_t __gid);

// TODO: setregid, setegid
// TODO: getresuid, getresgid, setresuid, setresgid
// TODO: fork, vfork
// TODO: ttyname, isatty, ttyslot
// TODO: link, linkat, symlink, readlink, symlinkat, readlinkat, unlinkat
// TODO: rmdir
// TODO: tcgetpgrp, tcsetpgrp
// TODO: getlogin, getlogin_r, setlogin
// TODO: gethostname, sethostname, sethostid, getdomainname, setdomainname
// TODO: vhangup, revoke, profil
// TODO: ...

long syscall(long __sysno, ...);

// TODO: copy_file_range, fdatasync
// TODO: ...

/**
 * Linux specifc extension.
 */
pid_t gettid();
